Hack to have the required Date: and From: (I'm not sure the latter)
by RFC 2822
--- modules/mailparse.pl.orig	Thu Feb 16 23:19:47 2006
+++ modules/mailparse.pl	Fri Feb 17 00:00:12 2006
@@ -23,6 +23,10 @@
 require "modules/tool.pl";
 require "modules/mime.pl";
 
+require "modules/datetime.pl";
+
+use vars qw(%config %prefs);
+
 sub parse_header {
    # concatenate folding lines in header but not the last blank line
    my $header=${$_[0]}; $header=~s/\s+$//s; $header=~s/\s*\n\s+/ /sg;
@@ -34,6 +38,17 @@
       last if (! /(.+?):\s*(.*)/);
       next if ($1 eq 'Received');
       ${$r_message}{lc($1)}=$2;
+   }
+   # 060216.rafan hack to have the required Date: field (RFC 2822)
+   if (!defined(${$r_message}{date}) || ${$r_message}{date} eq 'N/A') {
+      my $t = ow::datetime::delimiter2dateserial(${$r_message}{delimiter}, $config{'deliver_use_gmt'}, $prefs{'daylightsaving'});
+      my $d = ow::datetime::dateserial2datefield($t, $prefs{'timeoffset'}, $prefs{'daylightsaving'});
+      ${$r_message}{date} = $d;
+   }
+   # 060216.rafan hack to have From:
+   if (!defined(${$r_message}{from}) || ${$r_message}{from} eq 'N/A') {
+      my @f = split(/\s+/, ${$r_message}{delimiter});
+      ${$r_message}{from} = $f[1];
    }
    return;
 }
